/*
 * -- Copyright 2000 --
 * George Greer <greerga@m-l.org>
 * Corey Sanders <corey.sanders@email.com>
 *
 * Licensed under the GNU General Public License (GPL) v2 (only).
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *   or visit ftp://ftp.gnu.org/pub/gnu/COPYING via the Internet.
 */

#include <stdlib.h>
#include <assert.h>
#include "algol60.h"

struct block_s *root_block, *current_block;

void blockinit()
{
  root_block = (struct block_s *) calloc(1, sizeof(struct block_s));
  assert(root_block != NULL);
  root_block->prev = NULL;

  current_block = root_block;
}

void blockpush()
{
  struct block_s *next; 
  next = (struct block_s *) calloc(1, sizeof(struct block_s));
  assert(next != NULL);

  next->symbol_table = (struct symtab *) calloc(1, sizeof(struct symtab));
  assert(next->symbol_table != NULL); 

  syminit(next);

  next->prev = current_block;
  current_block = next;
}

void blockpop()
{
  struct block_s *junk;

  assert(current_block != NULL);

  junk = current_block;
  current_block = current_block->prev;

  symclean(junk); 
  free(junk->symbol_table);
  free(junk);
}
