
enum e_calltype {
  BYREF,
  BYVAL
};

enum e_type {
  INTEGER,
  REAL,
  BOOL,
  PROCEDURE,
  VOID
};

struct symtab {
	char 		  *name;
	enum e_type	  type;
	enum e_calltype   callby;
};


void syminit(struct block_s *block);
void symclean(struct block_s *block);
struct symtab *symlook(struct block_s *block, const char *s);
struct symtab *syminsert(struct block_s *block, const char *name, enum e_type type, enum e_calltype callby);
struct symtab *symtempvar(enum e_type type);
const char *symtype(enum e_type type);
struct symtab *symiliteral(long val);
struct symtab *symrliteral(float val);
int symdeclok(struct block_s *block, struct symtab *sp);
void symdump(struct block_s *block);
void symdeclparam(void); 
