/*
 * -- Copyright 2000 --
 * George Greer <greerga@m-l.org>
 * Corey Sanders <corey.sanders@email.com>
 *
 * Licensed under the GNU General Public License (GPL) v2 (only).
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *   or visit ftp://ftp.gnu.org/pub/gnu/COPYING via the Internet.
 */

#include "algol60.h"

static stack_t *labels;

void labelinit(void)
{
  labels = newstack();
}

char * labelpush(void)
{
  static unsigned int nlabels = 0;
  char junk[32];
  char *newlabel;

  sprintf(junk, ":label&&%u", nlabels++);
  newlabel = strdup(junk);

  push(labels, newlabel);
  return newlabel;
}

char * labelpop(void)
{
  char *junk = (char *) pop(labels);
  static char oldlabel[32]; 

  strcpy(oldlabel, junk);
  free(junk);

  return oldlabel;
}
